//
// $Id: Roundtrip.cpp 76591 2007-01-25 18:17:52Z elliott_c $
//
#include "Roundtrip.h"

ACE_RCSID(AMI_Latency, Roundtrip, "$Id: Roundtrip.cpp 76591 2007-01-25 18:17:52Z elliott_c $")

Roundtrip::Roundtrip (CORBA::ORB_ptr orb)
  : orb_ (CORBA::ORB::_duplicate (orb))
{
}

Test::Timestamp
Roundtrip::test_octet_method (const Test::octet_load &,
                              Test::Timestamp send_time)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return send_time;
}

Test::Timestamp
Roundtrip::test_long_method (const Test::long_load &,
                              Test::Timestamp send_time)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return send_time;
}

Test::Timestamp
Roundtrip::test_char_method (const Test::char_load &,
                             Test::Timestamp send_time)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return send_time;
}

Test::Timestamp
Roundtrip::test_longlong_method (const Test::longlong_load &,
                                 Test::Timestamp send_time)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return send_time;
}

Test::Timestamp
Roundtrip::test_double_method (const Test::double_load &,
                               Test::Timestamp send_time)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return send_time;
}


Test::Timestamp
Roundtrip::test_short_method (const Test::short_load &,
                              Test::Timestamp send_time)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  return send_time;
}

void
Roundtrip::shutdown (void)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  this->orb_->shutdown (0);
}
